package bin;

import kernel.peripherals.Peripherals.Peripheral;
import lib.CLIAppBase;

using tink.CoreApi;

@:build(macros.Binstore.includeBin("Speaker", ["speaker", "sp"]))
class Speaker extends CLIAppBase {
	public function new() {
		registerSyncSubcommand("note", (args) -> {
			var sp = Peripheral.getSpeaker(args.getString("addr"));

			var note = args.getString("note");
			var r;

			if (args.hasArg("pitch")) {
				if (args.hasArg("volume")) {
					r = sp.playNote(note, args.getFloat("volume"), args.getInt("pitch"));
				} else {
					r = sp.playNote(note, args.getFloat("volume"));
				}
			} else {
				r = sp.playNote(note);
			}

			switch r {
				case Failure(failure):
					handle.writeLine(failure);
					return false;
				case Success(_):
					return true;
			}
		}, [
			Peripheral("addr", kernel.peripherals.Speaker.TYPE_NAME),
			String("note"),
			Optional(Int("pitch")),
			Optional(Float("volume"))
		]);

		registerSyncSubcommand("sound", (args) -> {
			var sp = Peripheral.getSpeaker(args.getString("addr"));

			var sound = args.getString("sound");
			var r;

			if (args.hasArg("volume")) {
				if (args.hasArg("pitch")) {
					r = sp.playSound(sound, args.getFloat("volume"), args.getFloat("pitch"));
				} else {
					r = sp.playSound(sound, args.getFloat("volume"));
				}
			} else {
				r = sp.playSound(sound);
			}

			switch r {
				case Failure(failure):
					handle.writeLine(failure);
					return false;
				case Success(_):
					return true;
			}
		}, [
			Peripheral("addr", kernel.peripherals.Speaker.TYPE_NAME),
			String("sound"),
			Optional(Float("pitch")),
			Optional(Float("volume"))
		]);
	}
}
