package bin.debug;

import kernel.log.Log;
import lib.turtle.InvManager;
import kernel.ps.ProcessHandle;
import kernel.ps.IProcess;

/**
	Use this to test whatever you are working on. It will also print debug statements. 
	IDK if you commit changes in this file. It will not be included in non debug build.
**/
#if debug
@:build(macros.Binstore.includeBin("Debug", ["dbg", "debug"]))
#end
class Debug implements IProcess {
	public function new() {}

	public function run(handle:ProcessHandle) {
		var link = Log.onLog.handle((line) -> {
			handle.writeLine('[${line.level}] ${line.message}');
		});

		handle.addDeferFunc(() -> {
			link.cancel();
		});

		// Add your stuff here
		// -----

		var rpc = new bin.debug.DebugRPC.DebugRPCImpl(1, "debug");

		var a = rpc.addNumber(1, 2);

		// rpc.addNumber(1,2).handle((e)->{
		// 	Log.debug(e);
		// 	handle.close();
		// });

		// -----
	}
}
