package bin.ns;

import lib.CLIAppBase;

using tink.CoreApi;

@:build(macros.Binstore.includeBin("NameSystemCLI", ["ns-cli"]))
class NameSystemCLI extends CLIAppBase {
	public function new() {
		registerAsyncSubcommand("get", (args) -> {
			var ns = NameSystemRPC.getDefault();

			return ns.getIDRecord(args.getString("name")).map((r) -> {
				switch r {
					case Success(data):
						handle.writeLine('Resolved: $data');
					case Failure(failure):
						handle.writeLine('Failed: $failure');
				}

				return true;
			});
		}, [String("name")]);

		registerAsyncSubcommand("register", (args) -> {
			var id = args.getInt("id");
			var ns = NameSystemRPC.getDefault();

			return ns.setIDRecord(args.getString("name"), id).map((r) -> {
				switch r {
					case Success(_):
						handle.writeLine('Set');
					case Failure(failure):
						handle.writeLine('Failed: $failure');
				}

				return true;
			});
		}, [String("name"), Int("id")]);

		registerAsyncSubcommand("list", (args) -> {
			var ns = NameSystemRPC.getDefault();

			return ns.listIDRecords().map((r) -> {
				switch r {
					case Success(data):
						handle.writeLine('List: $data');
					case Failure(failure):
						handle.writeLine('Failed: $failure');
				}

				return true;
			});
		});

		registerAsyncSubcommand("unregister", (args) -> {
			var ns = NameSystemRPC.getDefault();

			return ns.removeIDRecord(args.getString("name")).map((r) -> {
				switch r {
					case Success(_):
						handle.writeLine('Unregisterd');
					case Failure(failure):
						handle.writeLine('Failed: $failure');
				}

				return true;
			});
		}, [String("name")]);
	}
}
