package lib.ui.elements;

import kernel.log.Log;
import kernel.ButtonType;
import lib.ui.rendere.IUIEventDelegate;

class UIEventManager implements IUIEventDelegate {
	private var map:EventMap = new EventMap();

	public function new() {}

	public function clearMap() {
		this.map = new EventMap();
	}

	public function addMapElement(element:IUIEventDelegate, bound:Rect) {
		this.map.addElement(element, bound);
	}

	public function getEventHandlers():UIEvents {
		return {
			onClick: handleClickEvent,
			onKey: handleKeyEvent,
			onKeyUp: handleKeyUpEvent,
			onMouseDrag: handleMouseDragEvent,
			onMouseScroll: handleMouseScrollEvent,
			onMouseUp: handleMouseUpEvent,
			onPaste: handlePasteEvent,
			onChar: handleCharEvent,
		};
	}

	private function handleClickEvent(params:{button:ButtonType, pos:Pos}) {
		var element = this.map.findResponseableDelegate(params.pos);
		if (element == null) {
			return;
		}

		var handlers = element.getEventHandlers();
		if (handlers == null || handlers.onClick == null) {
			return;
		}

		handlers.onClick.invoke(params);
	}

	private function handleCharEvent(char:String) {}

	private function handlePasteEvent(text:String) {}

	private function handleMouseUpEvent(params:{button:ButtonType, pos:Pos}) {}

	private function handleMouseScrollEvent(params:{dir:Int, pos:Pos}) {}

	private function handleMouseDragEvent(params:{button:ButtonType, pos:Pos}) {}

	private function handleKeyEvent(params:{keyCode:Int, isHeld:Bool}) {}

	private function handleKeyUpEvent(key:Int) {}
}
